#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long n;

    int k;
    cin>>n>>k;

    vector<long long> a(k);

    long long xr = 0;

    for(int i=0;i<k;i++){
        cin>>a[i];
        xr ^= a[i];
    }

    for(int i =0;i<k;i++){

        long long br = a[i];
        xr = 1;
        if(br != 1){
            xr ^= br;
        }
        for(int j = 2;j*j<=br;j++){
            if(br % j == 0){
                xr ^= j;
                if(j == br/j){
                    continue;
                }
                xr ^= br/j;

            }
        }

        cout<<xr<<' ';
    }


    return 0;
}